Debian Bug report logs - #606966
sync() may block for very long periods - writeback problem?

version graph

Package: linux-2.6; Maintainer for linux-2.6 is Debian Kernel Team <debian-kernel@lists.debian.org>;

Reported by: Sam Morris <sam@robots.org.uk>

Date: Mon, 13 Dec 2010 12:39:02 UTC

Severity: important

Tags: fixed-upstream

Merged with 595927, 600075

Found in versions 2.6.32-21, 2.6.38-4

Fixed in version 3.2~rc4-1~experimental.1

Done: Ben Hutchings <ben@decadent.org.uk>

Bug is archived. No further changes may be made.

Forwarded to https://bugzilla.kernel.org/show_bug.cgi?id=18632

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#606966; Package dpkg. (Mon, 13 Dec 2010 12:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sam Morris <sam@robots.org.uk>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 13 Dec 2010 12:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sam Morris <sam@robots.org.uk>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg: Hang when unpacking a package
Date: Mon, 13 Dec 2010 12:36:59 +0000
Package: dpkg
Version: 1.15.8.5
Severity: normal

dpkg hung while unpacking a package:

  $ sudo aptitude install cgroup-bin
  Reading package lists... Done
  Building dependency tree       
  Reading state information... Done
  Reading extended state information      
  Initializing package states... Done
  Writing extended state information... Done
  Reading task descriptions... Done         
  The following NEW packages will be installed:
	cgroup-bin libcgroup1{a} 
  0 packages upgraded, 2 newly installed, 0 to remove and 0 not upgraded.
  Need to get 92.5kB of archives. After unpacking 438kB will be used.
  Do you want to continue? [Y/n/?] 
  Writing extended state information... Done
  Get:1 http://ftp.uk.debian.org squeeze/main libcgroup1 0.36.2-3 [35.8kB]
  Get:2 http://ftp.uk.debian.org squeeze/main cgroup-bin 0.36.2-3 [56.7kB]
  Fetched 92.5kB in 0s (236kB/s)  
  Selecting previously deselected package libcgroup1.
  (Reading database ... 113181 files and directories currently installed.)
  Unpacking libcgroup1 (from .../libcgroup1_0.36.2-3_amd64.deb) ...

Kernel log messages:

  [5416663.481108] dpkg          D ffff880006e0fa20     0 28315  26400 0x00000000
  [5416663.481115]  ffffffff8145d1f0 0000000000000082 0000000000000000 ffff880031a03e98
  [5416663.481124]  0000000000000000 000000000000f9e0 ffff880031a03fd8 0000000000015780
  [5416663.481133]  0000000000015780 ffff880045c6e9f0 ffff880045c6ece8 0000000081041307
  [5416663.481142] Call Trace:
  [5416663.481153]  [<ffffffff8110780f>] ? bdi_sched_wait+0x0/0xe
  [5416663.481160]  [<ffffffff81107818>] ? bdi_sched_wait+0x9/0xe
  [5416663.481165]  [<ffffffff812f9e45>] ? __wait_on_bit+0x41/0x70
  [5416663.481169]  [<ffffffff8110780f>] ? bdi_sched_wait+0x0/0xe
  [5416663.481173]  [<ffffffff812f9edf>] ? out_of_line_wait_on_bit+0x6b/0x77
  [5416663.481177]  [<ffffffff81064a08>] ? wake_bit_function+0x0/0x23
  [5416663.481181]  [<ffffffff81107890>] ? sync_inodes_sb+0x73/0x12a
  [5416663.481186]  [<ffffffff8110b3f5>] ? __sync_filesystem+0x4b/0x70
  [5416663.481189]  [<ffffffff8110b4b4>] ? sync_filesystems+0x9a/0xe3
  [5416663.481193]  [<ffffffff8110b542>] ? sys_sync+0x1c/0x2e
  [5416663.481197]  [<ffffffff81010b42>] ? system_call_fastpath+0x16/0x1b
  [5416783.438276] INFO: task dpkg:28315 blocked for more than 120 seconds.
  [5416783.438330] "echo 0 > /proc/sys/kernel/hung_task_timeout_secs" disables this message.

Files that are open:

  $ sudo lsof -n -p 28315
  COMMAND   PID USER   FD   TYPE DEVICE      SIZE     NODE NAME
  dpkg    28315 root  cwd    DIR  253,0      4096        2 /
  dpkg    28315 root  rtd    DIR  253,0      4096        2 /
  dpkg    28315 root  txt    REG  253,0    224960   187604 /usr/bin/dpkg
  dpkg    28315 root  mem    REG  253,0     47616   562323 /lib/libnss_files-2.11.2.so
  dpkg    28315 root  mem    REG  253,0     43552   562316 /lib/libnss_nis-2.11.2.so
  dpkg    28315 root  mem    REG  253,0     89064   562374 /lib/libnsl-2.11.2.so
  dpkg    28315 root  mem    REG  253,0     31616   562370 /lib/libnss_compat-2.11.2.so
  dpkg    28315 root  mem    REG  253,0 108805904   345146 /usr/lib/locale/locale-archive
  dpkg    28315 root  mem    REG  253,0     14696   562347 /lib/libdl-2.11.2.so
  dpkg    28315 root  mem    REG  253,0   1432968   562357 /lib/libc-2.11.2.so
  dpkg    28315 root  mem    REG  253,0    117848   561953 /lib/libselinux.so.1
  dpkg    28315 root  mem    REG  253,0    128744   562378 /lib/ld-2.11.2.so
  dpkg    28315 root  mem    REG  253,0     26048   309653 /usr/lib/gconv/gconv-modules.cache
  dpkg    28315 root    0u   CHR  136,5                  8 /dev/pts/5
  dpkg    28315 root    1u   CHR  136,5                  8 /dev/pts/5
  dpkg    28315 root    2u   CHR  136,5                  8 /dev/pts/5
  dpkg    28315 root    3uW  REG  253,2         0   224914 /var/lib/dpkg/lock
  dpkg    28315 root    4w   REG  253,2      4608   225141 /var/lib/dpkg/updates/tmp.i
  dpkg    28315 root    5u   REG  253,2         0   224917 /var/lib/dpkg/triggers/Lock
  dpkg    28315 root    6w   REG  253,2     47702    88580 /var/log/dpkg.log
  dpkg    28315 root    7r   REG  253,2       258   224947 /var/lib/dpkg/diversions
  dpkg    28315 root    8r   REG  253,2       111   225994 /var/lib/dpkg/statoverride
  dpkg    28315 root   36w  FIFO    0,8           15501320 pipe

dpkg.log:

  2010-12-13 12:27:41 startup archives unpack
  2010-12-13 12:27:43 install libcgroup1 <none> 0.36.2-3
  2010-12-13 12:27:43 status half-installed libcgroup1 0.36.2-3

-- System Information:
Debian Release: squeeze/sid
  APT prefers testing
  APT policy: (530, 'testing'), (520, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-5-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_GB.utf8, LC_CTYPE=en_GB.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages dpkg depends on:
ii  coreutils               8.5-1            GNU core utilities
ii  libbz2-1.0              1.0.5-6          high-quality block-sorting file co
ii  libc6                   2.11.2-7         Embedded GNU C Library: Shared lib
ii  libselinux1             2.0.96-1         SELinux runtime shared libraries
ii  xz-utils                5.0.0-2          XZ-format compression utilities
ii  zlib1g                  1:1.2.3.4.dfsg-3 compression library - runtime

dpkg recommends no packages.

Versions of packages dpkg suggests:
ii  apt                           0.8.8      Advanced front-end for dpkg

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#606966; Package dpkg. (Mon, 13 Dec 2010 18:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 13 Dec 2010 18:09:03 GMT) Full text and rfc822 format available.

Message #10 received at 606966@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Sam Morris <sam@robots.org.uk>
Cc: 606966@bugs.debian.org
Subject: Re: dpkg: Hang when unpacking a package
Date: Mon, 13 Dec 2010 12:05:46 -0600
forcemerge 595927 606966
quit

Hi Sam,

Sam Morris wrote:

> Package: dpkg
> Version: 1.15.8.5
> Severity: normal
>
> dpkg hung while unpacking a package:
[...]
>   [5416783.438276] INFO: task dpkg:28315 blocked for more than 120 seconds.
>   [5416783.438330] "echo 0 > /proc/sys/kernel/hung_task_timeout_secs" disables this message.
[...]
> Kernel: Linux 2.6.32-5-amd64 (SMP w/2 CPU cores)

Looks like <http://bugs.debian.org/595927>.  Probably you would
like v1.15.8.6.

I think the kernel could be smarter[1] about distinguishing between a
hung task and slow sync(), but that's another story.

Thanks for reporting,

[1] https://bugzilla.kernel.org/show_bug.cgi?id=18632




Forcibly Merged 595927 600075 606966. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Mon, 13 Dec 2010 18:09:06 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 11 Jan 2011 07:31:17 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Bernd Zeimetz <bernd@bzed.de> to control@bugs.debian.org. (Fri, 20 May 2011 07:15:04 GMT) Full text and rfc822 format available.

Bug No longer marked as fixed in versions dpkg/1.15.8.6 and reopened. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 20 May 2011 07:21:04 GMT) Full text and rfc822 format available.

Bug reassigned from package 'dpkg' to 'linux-2.6'. Request was from Bernd Zeimetz <bernd@bzed.de> to control@bugs.debian.org. (Fri, 20 May 2011 07:21:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions dpkg/1.15.8.5. Request was from Bernd Zeimetz <bernd@bzed.de> to control@bugs.debian.org. (Fri, 20 May 2011 07:21:07 GMT) Full text and rfc822 format available.

Bug Marked as found in versions 2.6.38-4. Request was from Bernd Zeimetz <bernd@bzed.de> to control@bugs.debian.org. (Fri, 20 May 2011 07:21:10 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'critical' Request was from Bernd Zeimetz <bernd@bzed.de> to control@bugs.debian.org. (Fri, 20 May 2011 07:21:12 GMT) Full text and rfc822 format available.

Changed Bug title to 'sync() may block for very long periods - writeback problem?' from 'dpkg: Hang when unpacking a package' Request was from Ben Hutchings <ben@decadent.org.uk> to control@bugs.debian.org. (Fri, 13 Jan 2012 04:18:08 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from bts-link-upstream@lists.alioth.debian.org to control@bugs.debian.org. (Mon, 20 Aug 2012 16:53:11 GMT) Full text and rfc822 format available.

Marked as found in versions 2.6.32-21. Request was from Ben Hutchings <ben@decadent.org.uk> to control@bugs.debian.org. (Tue, 21 Aug 2012 02:24:05 GMT) Full text and rfc822 format available.

Message #33 received at 595927-done@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: 595927-done@bugs.debian.org
Subject: Re: sync() may block for very long periods - writeback problem?
Date: Tue, 21 Aug 2012 03:44:34 +0100
[Message part 1 (text/plain, inline)]
Version: 3.2~rc4-1~experimental.1

A lot of improvements to writeback went into 3.2, and the upstream bug
report for this is now marked as resolved.  Hopefully this is the case.

Ben.

-- 
Ben Hutchings
The most exhausting thing in life is being insincere. - Anne Morrow Lindberg
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 21 Sep 2012 07:30:22 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 04:31:06 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.